const test = require('tape')
const ploy = require('../../../')
const taskBuildJS = require('../')

test.onFinish(() => process.exit())

test('simple js build (with cwd)', { timeout: 2000 }, t => {
  ploy.set({
    cwd: __dirname,
    tasks: {
      inject: [ taskBuildJS ],
      simpleBuild: {
        type: 'build-js',
        options: {
          entry: [ 'files/foo.js', 'files/a.js' ]
        }
      }
    }
  })

  t.plan(2)

  const simpleBuild = ploy.get(['tasks', 'simpleBuild'], {})

  simpleBuild.get(['result', 'node'], {})
    .once(code => code.compute() && ~code.compute().indexOf('console.log(\'hello world\')'))
    .then(code => t.pass('output build code'))

  simpleBuild.get('done', {})
    .once(done => done.compute())
    .then(done => t.pass('set done'))
})
