const test = require('tape')
const ploy = require('../../../')
const hubClient = require('../')
const fs = require('fs')

test.onFinish(() => process.exit())

test('hub client', { timeout: 2000 }, t => {
  ploy.set({
    cwd: __dirname,
    tasks: {
      inject: [ hubClient ],
      one: () => new Promise(resolve => resolve({ done: true })),
      two: () => new Promise(resolve => resolve({ done: true })),
      hubClient: {
        type: 'hub-client',
        options: {
          reload: [ 'one', 'two' ]
        }
      }
    }
  })

  ploy.on('error', data => console.log(data))

  ploy.get(['tasks', 'hubClient', 'result'], {})
    .once(result => result.compute())
    .then(() => t.pass('creates result'))
    .then(() => fs.stat(
      `${__dirname}/.tasks.hubClient.js`,
      err => {
        err ? t.pass('removed tmp file') : t.fail('did not remove tmp file')
        t.end()
      }
    ))
})
