const h = require('hub.js')
const bs = require('stamp')
const hub = h({ url: process.env.PLOY_TASK_HUB })
const start = bs.create()
const date = Date.now()

hub.connected.once(true).then(() => {
  console.log('✨ connected to ploy-task-hub! ✨')
  // console.log('WAAAH', /Chrome/.test(navigator.userAgent))
})

hub.subscribe({
  tasks: {
    reload: {
      done: true
    }
  }
}, s => {
  if (s.compute() > start && (Date.now() > date + 500)) {
    if (Date.now() > date + 500) {
      reload()
    }
  }
})

hub.on('error', (err) => {
  console.log('- error from ${err.origin} -')
  console.error(err.message)
})

const reload = () => {
  if (process.env.PLOY_TASK_SERVER) {
    global.fetch(process.env.PLOY_TASK_SERVER).then(res => {
      global.location.reload()
    }).catch(e => {
      setTimeout(reload, 100)
    })
  } else {
    global.location.reload()
  }
}
