const http = require('http')
const { join } = require('path')
const findPort = require('../../src/util/find-port')
const getIp = require('../../src/util/get-ip')

exports.tasks = {
  'livereload-browser': {
    type: 'build-js',
    options: { entry: join(__dirname, 'browser.js') }
  },
  'livereload-server': {
    val: task => {
      findPort(3033).then(port => {
        console.log('go listen to a port')
        http.createServer((req, res) => {
          task.options.script.once(val => {
            return typeof val.compute() === 'string'
          }).then(() => {
            res.end(task.options.script.compute())
          })
        }).listen(port)
        process.env.PLOY_TASK_LIVERELOAD = `http://${getIp()}:${port}`
        task.set({ result: port, done: true })
      })
    },
    after: [ 'livereload-browser' ],
    options: {
      script: [ '@', 'parent', 'parent', 'parent', 'livereload-browser', 'result', 'inline' ]
    }
  }
}
