const ploy = require('../../')
const compress = require('./tasks/compress')
const resize = require('./tasks/resize')
const rotate = require('./tasks/rotate')

ploy.set({
  tasks: {
    inject: [ compress, resize, rotate ],
    resizeIcon: {
      type: 'resize',
      options: {
        entry: './files/icon.png',
        width: 100,
        height: 100
      }
    },
    rotateIcon: {
      type: 'rotate',
      options: {
        entry: './files/icon.png',
        deg: 180
      },
      after: [ 'resizeIcon' ]
    },
    compressIcon: {
      type: 'compress',
      options: {
        entry: './files/icon.png',
        size: 240
      },
      after: [ 'rotateIcon' ]
    },
    nestedTask: {
      val: task => new Promise(resolve => {
        console.log('nested tasks...')
        task.set({
          tasks: {
            oneThing: () => new Promise(resolve => {
              console.log('nested one...')
              setTimeout(() => resolve({ done: true }), 500)
            }),
            anotherThing: {
              val: () => new Promise(resolve => {
                console.log('nested two...')
                setTimeout(() => resolve({ done: true }), 500)
              }),
              after: [ 'oneThing' ],
              done: {
                on: val => resolve({ done: true })
              }
            }
          }
        })
      }),
      after: [ 'compressIcon' ]
    }
  },
  done: {
    on: val => {
      console.log('done!')
      process.exit()
    }
  }
})
